/*
 *  Kerrighed/kernel/kerrighed/sched.c
 *
 *  Copyright (C) 2007-2008 Louis Rilling - Kerlabs
 */

#include <linux/module.h>
#ifdef CONFIG_KRG_SCHED_CONFIG
#include <kerrighed/module_hook.h>
#endif

/* Kerrighed hooks */

struct task_struct;

#ifdef CONFIG_KRG_SCHED_LEGACY
void (*kh_calc_load)(unsigned long ticks);
/* Hook in the add_to_runqueue function of the kernel scheduler */
void (*kh_process_on)(struct task_struct *tsk);
/* Hook in the del_from_runqueue function of the kernel scheduler */
void (*kh_process_off)(struct task_struct *tsk);

EXPORT_SYMBOL(kh_calc_load);
EXPORT_SYMBOL(kh_process_on);
EXPORT_SYMBOL(kh_process_off);
#endif /* CONFIG_KRG_SCHED_LEGACY */

#ifdef CONFIG_KRG_SCHED_CONFIG
struct module_hook_desc kmh_calc_load;
/* Hook in the add_to_runqueue function of the kernel scheduler */
struct module_hook_desc kmh_process_on;
/* Hook in the del_from_runqueue function of the kernel scheduler */
struct module_hook_desc kmh_process_off;

EXPORT_SYMBOL(kmh_calc_load);
EXPORT_SYMBOL(kmh_process_on);
EXPORT_SYMBOL(kmh_process_off);
#endif /* CONFIG_KRG_SCHED_CONFIG */

int (*kh_copy_sched_info)(struct task_struct *tsk);
void (*kh_free_sched_info)(struct task_struct *tsk);

EXPORT_SYMBOL(kh_copy_sched_info);
EXPORT_SYMBOL(kh_free_sched_info);

/* vanilla Linux symbols */

#include <linux/fs_struct.h>

EXPORT_SYMBOL(set_fs_root);
